{$mode objfpc}

uses sysutils,uev3,rubiroButtons,uev3Devices,rubiroSensors,rubiroMotors,rubiroSound,rubiroScreen,uev3Image,uev3sysfs;
 var
  ev3sensors:array[1..4]of TEv3Sensor=(nil,nil,nil,nil);
  ev3motors:array[1..4]of TEv3Motor=(nil,nil,nil,nil);

  current: TEv3Port=in1;//ev3pUnknown;

var
 RD,LD,UD,DD,CD:boolean;
 chng:boolean;

procedure showports();
 var w,x,v:integer; d:variant; s:string;  space:integer=5;  h:integer=20; i:integer;
begin
  w:=(((ev3Width-1)-3*space) div 4);
  ev3screen.clear;
  x:=1;
  v:=1;
  for i:=1 to 4 do begin
    ev3screen.rectangle(x,v,x+w,v+h)
    .fontStd()
    .print(x+w div 2 - space,v+h-2,i);
   if ev3sensors[i] is Tev3UltraSensor then begin
     s:='ULT';//'РСТ';
     d:=(ev3sensors[i] as Tev3UltraSensor).lenCM;
    end
    else
    if ev3sensors[i] is Tev3ColorSensor then begin
     with (ev3sensors[i] as Tev3ColorSensor) do begin
      if (ord(current)=i) and CD and not chng then begin
       //writeln (CD,' ',chng);
       chng:=true;
       if mode=smCOLOR then mode:=smREFLECT else mode:=succ(mode);
      end;
      case mode of
        smREFLECT: begin
                   s:='REF';//'СВТ';
                   d:=reflect; // доп.проверка на режимы!!!
        end;
        smAMBIENT: begin
                   s:='AMB';//'ОСВ';
                   d:=ambient; // доп.проверка на режимы!!!
        end;
        smCOLOR: begin
                   s:='COL';//'ЦВТ';
                   d:=color; // доп.проверка на режимы!!!
        end;
      end;
     end;
    end
    else
    if ev3sensors[i] is Tev3TouchSensor then begin
     s:='TCH';//;'КНП';
     d:=(ev3sensors[i] as Tev3TouchSensor).pressed;
    end
    else
    if ev3sensors[i] is Tev3GyroSensor then begin
     //smGYROANG,smGYRORATE,smGYROFAS,smGYROGA,smGYROCAL,smTILTRATE,smTILTANG
     with (ev3sensors[i] as Tev3GyroSensor) do begin
       if (ord(current)=i) and CD and not chng then begin
        //writeln (CD,' ',chng);
        chng:=true;
        if mode=smGYROANG then mode:=smGYRORATE
        else
        if mode=smGYRORATE then mode:=smTILTANG
        else
        if mode=smTILTANG then mode:=smTILTRATE
        else mode:=smGYROANG;
       end;
       case mode of
         smGYROANG: begin
                  s:='ANG';//;'УГЛ';
                  d:=angle;
         end;
         smGYRORATE: begin
                  s:='RTE';//'СКР';
                  d:=speed;
         end;
         smTILTANG: begin
                  s:='TAN';//'НКУ';
                  d:=tiltAngle;
         end;
         smTILTRATE: begin
                  s:='TRT';//;'НКС';
                  d:=tiltSpeed;
         end;
       end;
      end;
    end
    else
    if ev3sensors[i] is TnxtTouchSensor then begin
     s:='nTch';
     d:=(ev3sensors[i] as TnxtTouchSensor).pressed;
    end
    else
    if ev3sensors[i] is Tev3Sensor then begin
     s:='  ???';
     d:=(ev3sensors[i] as Tev3Sensor).value0;
    end
    else begin
      s:='  ---';
      d:='';
    end;
    ev3Screen.rectangle(x,v+h,x+w,v+h+h)
    .fontSize(11).print(x+2,v+h+h-2,s)
    .rectangle(x,v+h+h,x+w,v+h+h+h)
    .fontSize(9).print(x+2,v+h+h+h-2,d);
    if ord(current)=i then
     ev3screen.rectangle(x-1,v-1,x+w+1,v+h+1).
     rectangle(x-1,v+h-1,x+w+1,v+h+h+1).
     rectangle(x-1,v+h+h-1,x+w+1,v+h+h+h+1);

    x+=w+space;
  end;

  x:=1;
  v:=(ev3height-1)-h-1;

  for i:=1 to 4 do begin
    ev3screen.rectangle(x,v,x+w,v+h)
    .fontStd()
    .print(x+w div 2 - space,v+h-2,chr(ord('A')+i-1));
    if ev3motors[i] is Tev3LargeMotor then begin
     s:='LRG';//;'БОЛ';
     d:=(ev3motors[i] as Tev3LargeMotor).position;
    end
    else
    if ev3motors[i] is Tev3MediumMotor then begin
     s:='MID';//'СРД';
     d:=(ev3motors[i] as Tev3MediumMotor).position;
    end
    else
    if ev3motors[i] is Tev3Motor then begin
     s:='  ???';
     d:='';
    end
    else begin
      s:='  ---';
      d:='';
    end;
    ev3Screen.rectangle(x,v-h,x+w,v)
    .fontSize(11).print(x+2,v-2,s)
    .rectangle(x,v-h-h,x+w,v-h)
    .fontSize(9).print(x+2,v-h-2,d);

    if ord(current)-4=i then
     ev3screen.rectangle(x-1,v-1,x+w+1,v+h+1).
     rectangle(x-1,v-h-1,x+w+1,v+1).
     rectangle(x-1,v-h-h-1,x+w+1,v-h+1);
    x+=w+space;
  end;
  ev3screen.show;
end;



procedure init();
 var k:TEv3Port;
begin
  ev3DeviceFactory.Refresh(true);
//  ev3DeviceFactory.Refresh();
//  writeln('init sensors');
   for k:=in1 to in4 do begin
    // if (k=in3)and assigned(ev3sensors[ord(k)]) then writeln(ev3sensors[ord(k)].connected);
     if assigned(ev3sensors[ord(k)]) and not ev3sensors[ord(k)].connected then freeandnil(ev3sensors[ord(k)]);
     if assigned(ev3sensors[ord(k)]) then continue;
     if not assigned(ev3DeviceFactory.Devices[k]) then continue;
     case ev3DeviceFactory.Devices[k].Device of
      ev3tUltraSensor: ev3sensors[ord(k)]:=Tev3UltraSensor.create(k);
      ev3tGyroSensor : ev3sensors[ord(k)]:=Tev3GyroSensor.create(k);
      ev3tColorSensor: ev3sensors[ord(k)]:=Tev3ColorSensor.create(k);
      ev3tTouchSensor: ev3sensors[ord(k)]:=Tev3TouchSensor.create(k);
      ev3tInfraSensor: ev3sensors[ord(k)]:=Tev3Sensor.create(k);
      nxttTouchSensor: ev3sensors[ord(k)]:=TnxtTouchSensor.create(k);
     end;
   end;

//   writeln('init motors');

   for k:=outA to outD do begin
     if assigned(ev3motors[ord(k)-4]) then freeandnil(ev3motors[ord(k)-4]);
     if not assigned(ev3DeviceFactory.Devices[k]) then continue;
     case ev3DeviceFactory.Devices[k].Device of
      ev3tLTachoMotor: ev3motors[ord(k)-4]:=Tev3LargeMotor.create(k);
      ev3tMTachoMotor: ev3motors[ord(k)-4]:=Tev3MediumMotor.create(k);
     end;
   end;
end;

begin
 ev3Init();
 countMaxRefreshFactory:=0; // при отключении датчика/мотора - без попыток переподключения
 while true do begin
  try
   while true do begin
    init();
    showports();
    if ev3buttons.Back then exit;
    if ev3buttons.center and not CD then begin
     CD:=true;
    end;
    if ev3buttons.Right and not RD then begin
     RD:=true;
     if current=outD then current:=in1
     else inc(current);
    end;
    if ev3buttons.Left and not LD then begin
     LD:=true;
     if current=in1 then current:=outD
     else dec(current);
    end;
    if ev3buttons.Up and not UD then begin
     ud:=true;
     if current<outA then inc(current,4)
     else dec(current,4);
    end;
    if ev3buttons.Down and not DD then begin
     dd:=true;
     if current<outA then inc(current,4)
     else dec(current,4);
    end;
    if not ev3buttons.Center then begin CD:=false; chng:=false; end;
    if not ev3buttons.Right then begin RD:=false; end;
    if not ev3buttons.Left then begin LD:=false;end;
    if not ev3buttons.Up then begin UD:=false;end;
    if not ev3buttons.Down then begin DD:=false;end;
   end;

  except
//    on e:Exception do begin
//     writeln(e.message); // 
//    end;
  end;

 end;
end.

