#!/bin/bash
# на входе - абсолютное имя исполяемого файла

if [[ -z $1 ]]
then
 exit
fi

. ~/bin/ev3env
elf=`basename $1`
lastmod=/tmp/$elf.lastmod
sec=`stat -c "%Y" $1`
lastsec=`stat -c "%Y" $lastmod 2>/dev/null`
if [[ "$lastsec" == "" ]]
then
 lastsec=0
 echo "Отладка: Первый запуск"
fi
if (($sec > $lastsec))
then
 echo "Отладка: Программа изменена, копирую на EV3"
 $ev3cp $1 $ev3cphost:/home/robot/ || exit 
fi
touch $lastmod
echo "Отладка: Запуск программы"
$ev3sh $ev3shopt $ev3shhost " echo '----------------------' && ./$elf" 
echo "----------------------"
echo "Отладка: Программа завершена, нажмите  клавишу Enter"
read
